Bug 813944 - missing TCP_CONGESTION
missing TCP_CONGESTION
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: ttcp (Show other bugs)
23
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Michal Sekletar
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-04-18 16:14 EDT by Curtis Doty
Modified: 2016-12-20 07:13 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-12-20 07:13:03 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Added implementation of -C command line option (2.87 KB, patch)
2012-05-31 05:46 EDT, Michal Sekletar
msekleta: review?
Details | Diff

  None (edit)
Description Curtis Doty 2012-04-18 16:14:57 EDT
It is missing the ability to set the TCP congestion control algorithm.
Comment 1 Michal Sekletar 2012-05-30 10:12:04 EDT
We can add new command line option. I think -C switch is unused so far,thus we can use it for this purpose. This RFE is easy to implement, however here is one concern we should take into the count. There is at least 5 or 6 congestion control algorithms I'm aware of and there is a mechanism in kernel to register and use new or customized algorithm, but only few of them are usable out-of-box, in my case only 2 (cubic, reno). I will implement this, without any restrictions on -C option value and I will assume that user is aware about choices he has available. We will try to set selected algorithm in everytime. If he picks algorithm which is not available on target system, setsockopt() will return failure and we will exit program with error code. I will add comment to man page how to put in use more algorithms by loading appropriate kernel modules.
Comment 2 Curtis Doty 2012-05-30 14:48:28 EDT
By default, only cubic and reno modules are loaded and allowed.

$ cat /proc/sys/net/ipv4/tcp_available_congestion_control 
cubic reno
$ cat /proc/sys/net/ipv4/tcp_allowed_congestion_control 
cubic reno

However, there are a bunch more available in the kernel. For example.

$ sudo modprobe tcp_htcp
$ cat /proc/sys/net/ipv4/tcp_available_congestion_control 
cubic reno htcp

Of course, it still can't be used until you authorize it like this.

$ sudo sh -c 'echo cubic reno htcp >>/proc/sys/net/ipv4/tcp_allowed_congestion_control'
$ cat /proc/sys/net/ipv4/tcp_allowed_congestion_control
cubic reno htcp

Tada! Now--I think--you should be able to setsockopt() with TCP_CONGESTION.

Not sure if there are different error conditions for "algorithm not loaded or unknown" and "algorithm not allowed."
Comment 3 Michal Sekletar 2012-05-31 05:46:00 EDT
Created attachment 588020 [details]
Added implementation of -C command line option
Comment 4 Fedora End Of Life 2013-07-04 02:20:50 EDT
This message is a reminder that Fedora 17 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 17. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '17'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 17's end of life.

Bug Reporter:  Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 17 is end of life. If you 
would still like  to see this bug fixed and are able to reproduce it 
against a later version  of Fedora, you are encouraged  change the 
'version' to a later Fedora version prior to Fedora 17's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 5 Jan Kurik 2015-07-15 11:09:47 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 23 development cycle.
Changing version to '23'.

(As we did not run this process for some time, it could affect also pre-Fedora 23 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 23 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora23
Comment 6 Fedora End Of Life 2016-11-24 05:38:47 EST
This message is a reminder that Fedora 23 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 23. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '23'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 23 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 7 Fedora End Of Life 2016-12-20 07:13:03 EST
Fedora 23 changed to end-of-life (EOL) status on 2016-12-20. Fedora 23 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.